//+------------------------------------------------------------------+
//|                                                 Hard scalper.mq4 |
//|                                                     Saasa Ivanov |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Saasa Ivanov"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrBlue
#property indicator_color2  clrRed


extern int    Period1         =  33;          // First period for WPR and CCI
extern int    Period2         =  33;          // Second period for WPR and CCI
extern double WprLevel1       = -55;          // Lower WPR level
extern double WprLevel2       = -46;          // Higher WPR level
extern double CCILevel1       = -35;          // Lower CCI level
extern double CCILevel2       =  38;          // Higher CCI level
extern bool   alertsOn        = true;         // alerts on?
extern bool   alertsOnCurrent = false;        // alerts on current (still open) bar?
extern bool   alertsMessage   = true;         // alerts message?
extern bool   alertsSound     = false;        // alerts sound?
extern bool   alertsNotify    = false;        // alerts notification?
extern bool   alertsEmail     = false;        // alerts email?
extern string soundFile       = "alert2.wav"; // alerts sound file
double dBuf0[], dBuf1[];

//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
int init() 
{
  SetIndexBuffer    (0, dBuf0); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0, 233);
  SetIndexBuffer    (1, dBuf1); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1, 234);
return(0);
}
int deinit() { return(0); }
int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   for (int i =limit; i>=0; i--) 
   {
      dBuf0[i]=EMPTY_VALUE;
      dBuf1[i]=EMPTY_VALUE;
      
      double MF19 = iWPR(NULL,0,Period1,i+0);
      double MF29 = iWPR(NULL,0,Period1,i+2);
      double CC3  = iCCI(NULL,0,Period2,PRICE_CLOSE,i+0);
      double CC4  = iCCI(NULL,0,Period2,PRICE_CLOSE,i+4);
    
      if ( MF19>WprLevel1 && MF29<WprLevel1 && CC3>CCILevel1 && CC4<CCILevel1) dBuf0[i]=Low[i] -iATR(NULL,0,10,i);
      if ( MF19<WprLevel2 && MF29>WprLevel2 && CC3<CCILevel2 && CC4>CCILevel2) dBuf1[i]=High[i]+iATR(NULL,0,10,i);
    }
    
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (dBuf0[whichBar+1] == EMPTY_VALUE && dBuf0[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up signal");
      if (dBuf1[whichBar+1] == EMPTY_VALUE && dBuf1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down signal");
    }         
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Hard scalper ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Hard scalper "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

